# coding: utf-8

"""
    Zadara Provisioning Portal API

     # Overview  This document outlines the methods available for creation and high-level administration of Zadara Storage VPSAs via a Zadara Storage Provisioning Portal. This API supports form-encoded requests, and can return either JSON or XML responses.  ## Endpoint  The base URL for the requests is the Provisioning Portal URL you created your VPSA through - for example: https://manage.zadarastorage.com/, and all APIs will be prefixed with /api as noted in the documentation below.  ## Authentication  To use this API, an authentication token is required. The API for retrieving this token can be found below in the Authentication section. You may pass this token in requests either via the the X-Token header or via basic authentication (base64 encoded) in Authorization header.  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp2
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ProvisioningPortal.api_client import ApiClient


class VlanApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def alloacate_vlan(self, alloacate_vlan, **kwargs):  # noqa: E501
        """alloacate_vlan  # noqa: E501

        Allocate a vlan  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.alloacate_vlan(alloacate_vlan, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AlloacateVlan alloacate_vlan: (required)
        :return: InlineResponse20022
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.alloacate_vlan_with_http_info(alloacate_vlan, **kwargs)  # noqa: E501
        else:
            (data) = self.alloacate_vlan_with_http_info(alloacate_vlan, **kwargs)  # noqa: E501
            return data

    def alloacate_vlan_with_http_info(self, alloacate_vlan, **kwargs):  # noqa: E501
        """alloacate_vlan  # noqa: E501

        Allocate a vlan  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.alloacate_vlan_with_http_info(alloacate_vlan, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AlloacateVlan alloacate_vlan: (required)
        :return: InlineResponse20022
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alloacate_vlan']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method alloacate_vlan" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alloacate_vlan' is set
        if self.api_client.client_side_validation and ('alloacate_vlan' not in params or
                                                       params['alloacate_vlan'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `alloacate_vlan` when calling `alloacate_vlan`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'alloacate_vlan' in params:
            body_params = params['alloacate_vlan']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/vlans/allocate.json', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20022',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def deallocate_vlan(self, deallocate_vlan, **kwargs):  # noqa: E501
        """deallocate_vlan  # noqa: E501

        Deallocate a vlan  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.deallocate_vlan(deallocate_vlan, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DeallocateVlan deallocate_vlan: (required)
        :return: InlineResponse20022
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.deallocate_vlan_with_http_info(deallocate_vlan, **kwargs)  # noqa: E501
        else:
            (data) = self.deallocate_vlan_with_http_info(deallocate_vlan, **kwargs)  # noqa: E501
            return data

    def deallocate_vlan_with_http_info(self, deallocate_vlan, **kwargs):  # noqa: E501
        """deallocate_vlan  # noqa: E501

        Deallocate a vlan  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.deallocate_vlan_with_http_info(deallocate_vlan, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DeallocateVlan deallocate_vlan: (required)
        :return: InlineResponse20022
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['deallocate_vlan']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method deallocate_vlan" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'deallocate_vlan' is set
        if self.api_client.client_side_validation and ('deallocate_vlan' not in params or
                                                       params['deallocate_vlan'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `deallocate_vlan` when calling `deallocate_vlan`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'deallocate_vlan' in params:
            body_params = params['deallocate_vlan']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/vlans/deallocate.json', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20022',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_availiable_vlan_for_provider(self, **kwargs):  # noqa: E501
        """list_availiable_vlan_for_provider  # noqa: E501

        Get list of available vlans  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_availiable_vlan_for_provider(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int provider_id: site id.
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_availiable_vlan_for_provider_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.list_availiable_vlan_for_provider_with_http_info(**kwargs)  # noqa: E501
            return data

    def list_availiable_vlan_for_provider_with_http_info(self, **kwargs):  # noqa: E501
        """list_availiable_vlan_for_provider  # noqa: E501

        Get list of available vlans  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_availiable_vlan_for_provider_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int provider_id: site id.
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['provider_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_availiable_vlan_for_provider" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'provider_id' in params:
            query_params.append(('provider_id', params['provider_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/vlans/available.json', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_availiable_vlans(self, **kwargs):  # noqa: E501
        """list_availiable_vlans  # noqa: E501

        Get the list of available vlans.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_availiable_vlans(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse20020
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_availiable_vlans_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.list_availiable_vlans_with_http_info(**kwargs)  # noqa: E501
            return data

    def list_availiable_vlans_with_http_info(self, **kwargs):  # noqa: E501
        """list_availiable_vlans  # noqa: E501

        Get the list of available vlans.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_availiable_vlans_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse20020
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_availiable_vlans" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/vlans.json', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20020',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def set_vlan_as_default(self, set_vlan_as_default, **kwargs):  # noqa: E501
        """set_vlan_as_default  # noqa: E501

        Set vlan as default  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.set_vlan_as_default(set_vlan_as_default, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SetVlanAsDefault set_vlan_as_default: (required)
        :return: InlineResponse20023
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.set_vlan_as_default_with_http_info(set_vlan_as_default, **kwargs)  # noqa: E501
        else:
            (data) = self.set_vlan_as_default_with_http_info(set_vlan_as_default, **kwargs)  # noqa: E501
            return data

    def set_vlan_as_default_with_http_info(self, set_vlan_as_default, **kwargs):  # noqa: E501
        """set_vlan_as_default  # noqa: E501

        Set vlan as default  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.set_vlan_as_default_with_http_info(set_vlan_as_default, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SetVlanAsDefault set_vlan_as_default: (required)
        :return: InlineResponse20023
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['set_vlan_as_default']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method set_vlan_as_default" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'set_vlan_as_default' is set
        if self.api_client.client_side_validation and ('set_vlan_as_default' not in params or
                                                       params['set_vlan_as_default'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `set_vlan_as_default` when calling `set_vlan_as_default`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'set_vlan_as_default' in params:
            body_params = params['set_vlan_as_default']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/vlans/set_as_default.json', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20023',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
