# coding: utf-8

"""
    Zadara Provisioning Portal API

     # Overview  This document outlines the methods available for creation and high-level administration of Zadara Storage VPSAs via a Zadara Storage Provisioning Portal. This API supports form-encoded requests, and can return either JSON or XML responses.  ## Endpoint  The base URL for the requests is the Provisioning Portal URL you created your VPSA through - for example: https://manage.zadarastorage.com/, and all APIs will be prefixed with /api as noted in the documentation below.  ## Authentication  To use this API, an authentication token is required. The API for retrieving this token can be found below in the Authentication section. You may pass this token in requests either via the the X-Token header or via basic authentication (base64 encoded) in Authorization header.  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp2
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from ProvisioningPortal.configuration import Configuration


class VpsaVirtualNetworkInterfaces(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'ip': 'str',
        'vni_id': 'int',
        'nova_id': 'int',
        'vlan_id': 'int',
        'cidr': 'str',
        'name': 'str',
        'vpsa_id': 'int'
    }

    attribute_map = {
        'id': 'id',
        'ip': 'ip',
        'vni_id': 'vni_id',
        'nova_id': 'nova_id',
        'vlan_id': 'vlan_id',
        'cidr': 'cidr',
        'name': 'name',
        'vpsa_id': 'vpsa_id'
    }

    def __init__(self, id=None, ip=None, vni_id=None, nova_id=None, vlan_id=None, cidr=None, name=None, vpsa_id=None, _configuration=None):  # noqa: E501
        """VpsaVirtualNetworkInterfaces - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._ip = None
        self._vni_id = None
        self._nova_id = None
        self._vlan_id = None
        self._cidr = None
        self._name = None
        self._vpsa_id = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if ip is not None:
            self.ip = ip
        if vni_id is not None:
            self.vni_id = vni_id
        if nova_id is not None:
            self.nova_id = nova_id
        if vlan_id is not None:
            self.vlan_id = vlan_id
        if cidr is not None:
            self.cidr = cidr
        if name is not None:
            self.name = name
        if vpsa_id is not None:
            self.vpsa_id = vpsa_id

    @property
    def id(self):
        """Gets the id of this VpsaVirtualNetworkInterfaces.  # noqa: E501

        Custom network id  # noqa: E501

        :return: The id of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VpsaVirtualNetworkInterfaces.

        Custom network id  # noqa: E501

        :param id: The id of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def ip(self):
        """Gets the ip of this VpsaVirtualNetworkInterfaces.  # noqa: E501

        Custom network ip address  # noqa: E501

        :return: The ip of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :rtype: str
        """
        return self._ip

    @ip.setter
    def ip(self, ip):
        """Sets the ip of this VpsaVirtualNetworkInterfaces.

        Custom network ip address  # noqa: E501

        :param ip: The ip of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :type: str
        """

        self._ip = ip

    @property
    def vni_id(self):
        """Gets the vni_id of this VpsaVirtualNetworkInterfaces.  # noqa: E501

        Virtual Network Interface id  # noqa: E501

        :return: The vni_id of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :rtype: int
        """
        return self._vni_id

    @vni_id.setter
    def vni_id(self, vni_id):
        """Sets the vni_id of this VpsaVirtualNetworkInterfaces.

        Virtual Network Interface id  # noqa: E501

        :param vni_id: The vni_id of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :type: int
        """

        self._vni_id = vni_id

    @property
    def nova_id(self):
        """Gets the nova_id of this VpsaVirtualNetworkInterfaces.  # noqa: E501

        Custom network Nova id  # noqa: E501

        :return: The nova_id of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :rtype: int
        """
        return self._nova_id

    @nova_id.setter
    def nova_id(self, nova_id):
        """Sets the nova_id of this VpsaVirtualNetworkInterfaces.

        Custom network Nova id  # noqa: E501

        :param nova_id: The nova_id of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :type: int
        """

        self._nova_id = nova_id

    @property
    def vlan_id(self):
        """Gets the vlan_id of this VpsaVirtualNetworkInterfaces.  # noqa: E501

        Custom network VLAN id  # noqa: E501

        :return: The vlan_id of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :rtype: int
        """
        return self._vlan_id

    @vlan_id.setter
    def vlan_id(self, vlan_id):
        """Sets the vlan_id of this VpsaVirtualNetworkInterfaces.

        Custom network VLAN id  # noqa: E501

        :param vlan_id: The vlan_id of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :type: int
        """

        self._vlan_id = vlan_id

    @property
    def cidr(self):
        """Gets the cidr of this VpsaVirtualNetworkInterfaces.  # noqa: E501

        Custom network cidr  # noqa: E501

        :return: The cidr of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :rtype: str
        """
        return self._cidr

    @cidr.setter
    def cidr(self, cidr):
        """Sets the cidr of this VpsaVirtualNetworkInterfaces.

        Custom network cidr  # noqa: E501

        :param cidr: The cidr of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :type: str
        """

        self._cidr = cidr

    @property
    def name(self):
        """Gets the name of this VpsaVirtualNetworkInterfaces.  # noqa: E501

        Custom network name  # noqa: E501

        :return: The name of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this VpsaVirtualNetworkInterfaces.

        Custom network name  # noqa: E501

        :param name: The name of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def vpsa_id(self):
        """Gets the vpsa_id of this VpsaVirtualNetworkInterfaces.  # noqa: E501

        VPSA id  # noqa: E501

        :return: The vpsa_id of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :rtype: int
        """
        return self._vpsa_id

    @vpsa_id.setter
    def vpsa_id(self, vpsa_id):
        """Sets the vpsa_id of this VpsaVirtualNetworkInterfaces.

        VPSA id  # noqa: E501

        :param vpsa_id: The vpsa_id of this VpsaVirtualNetworkInterfaces.  # noqa: E501
        :type: int
        """

        self._vpsa_id = vpsa_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VpsaVirtualNetworkInterfaces, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VpsaVirtualNetworkInterfaces):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, VpsaVirtualNetworkInterfaces):
            return True

        return self.to_dict() != other.to_dict()
