# coding: utf-8

"""
    Zadara VPSA Storage Array REST API

     # Overview  This document outlines the methods available for administrating your Zadara Storage VPSA&#8482;. The Zadara Storage Array REST API   supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the   Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or   through the X-Access-Key header.  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some  time to complete. When using the API, this can cause some actions, such as large volume creation, to be undesirably asynchronous.  You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Specific Fields For Product  Some of the fields/actions used in the API should be used only for a specific product. The following tags are used to mark which   product responds to the fields/actions  VPSA Flash Array  VPSA Storage Array - Hybrid VPSA  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp2
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Vpsa.configuration import Configuration


class CreateNasGroup(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'group_name': 'str',
        'nfs_gid': 'str',
        'smb': 'str'
    }

    attribute_map = {
        'group_name': 'group_name',
        'nfs_gid': 'nfs_gid',
        'smb': 'smb'
    }

    def __init__(self, group_name=None, nfs_gid=None, smb=None, _configuration=None):  # noqa: E501
        """CreateNasGroup - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._group_name = None
        self._nfs_gid = None
        self._smb = None
        self.discriminator = None

        self.group_name = group_name
        if nfs_gid is not None:
            self.nfs_gid = nfs_gid
        if smb is not None:
            self.smb = smb

    @property
    def group_name(self):
        """Gets the group_name of this CreateNasGroup.  # noqa: E501

        New group name  # noqa: E501

        :return: The group_name of this CreateNasGroup.  # noqa: E501
        :rtype: str
        """
        return self._group_name

    @group_name.setter
    def group_name(self, group_name):
        """Sets the group_name of this CreateNasGroup.

        New group name  # noqa: E501

        :param group_name: The group_name of this CreateNasGroup.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and group_name is None:
            raise ValueError("Invalid value for `group_name`, must not be `None`")  # noqa: E501

        self._group_name = group_name

    @property
    def nfs_gid(self):
        """Gets the nfs_gid of this CreateNasGroup.  # noqa: E501

        NFS new group id  # noqa: E501

        :return: The nfs_gid of this CreateNasGroup.  # noqa: E501
        :rtype: str
        """
        return self._nfs_gid

    @nfs_gid.setter
    def nfs_gid(self, nfs_gid):
        """Sets the nfs_gid of this CreateNasGroup.

        NFS new group id  # noqa: E501

        :param nfs_gid: The nfs_gid of this CreateNasGroup.  # noqa: E501
        :type: str
        """

        self._nfs_gid = nfs_gid

    @property
    def smb(self):
        """Gets the smb of this CreateNasGroup.  # noqa: E501


        :return: The smb of this CreateNasGroup.  # noqa: E501
        :rtype: str
        """
        return self._smb

    @smb.setter
    def smb(self, smb):
        """Sets the smb of this CreateNasGroup.


        :param smb: The smb of this CreateNasGroup.  # noqa: E501
        :type: str
        """

        self._smb = smb

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateNasGroup, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateNasGroup):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateNasGroup):
            return True

        return self.to_dict() != other.to_dict()
