# coding: utf-8

"""
    Zadara VPSA Storage Array REST API

     # Overview  This document outlines the methods available for administrating your Zadara Storage VPSA&#8482;. The Zadara Storage Array REST API   supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the   Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or   through the X-Access-Key header.  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some  time to complete. When using the API, this can cause some actions, such as large volume creation, to be undesirably asynchronous.  You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Specific Fields For Product  Some of the fields/actions used in the API should be used only for a specific product. The following tags are used to mark which   product responds to the fields/actions  VPSA Flash Array  VPSA Storage Array - Hybrid VPSA  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp2
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Vpsa.configuration import Configuration


class DetachSnapshotPolicy(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'snaprule': 'str',
        'delete_snapshots': 'str',
        'force': 'str'
    }

    attribute_map = {
        'snaprule': 'snaprule',
        'delete_snapshots': 'delete_snapshots',
        'force': 'force'
    }

    def __init__(self, snaprule=None, delete_snapshots=None, force=None, _configuration=None):  # noqa: E501
        """DetachSnapshotPolicy - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._snaprule = None
        self._delete_snapshots = None
        self._force = None
        self.discriminator = None

        self.snaprule = snaprule
        if delete_snapshots is not None:
            self.delete_snapshots = delete_snapshots
        if force is not None:
            self.force = force

    @property
    def snaprule(self):
        """Gets the snaprule of this DetachSnapshotPolicy.  # noqa: E501

        A snap rule ID. (found in /consistency_groups/{volume_cg_id}/snapshot_policies API)  # noqa: E501

        :return: The snaprule of this DetachSnapshotPolicy.  # noqa: E501
        :rtype: str
        """
        return self._snaprule

    @snaprule.setter
    def snaprule(self, snaprule):
        """Sets the snaprule of this DetachSnapshotPolicy.

        A snap rule ID. (found in /consistency_groups/{volume_cg_id}/snapshot_policies API)  # noqa: E501

        :param snaprule: The snaprule of this DetachSnapshotPolicy.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and snaprule is None:
            raise ValueError("Invalid value for `snaprule`, must not be `None`")  # noqa: E501

        self._snaprule = snaprule

    @property
    def delete_snapshots(self):
        """Gets the delete_snapshots of this DetachSnapshotPolicy.  # noqa: E501

        Delete Snapshots associated with the Policy.  # noqa: E501

        :return: The delete_snapshots of this DetachSnapshotPolicy.  # noqa: E501
        :rtype: str
        """
        return self._delete_snapshots

    @delete_snapshots.setter
    def delete_snapshots(self, delete_snapshots):
        """Sets the delete_snapshots of this DetachSnapshotPolicy.

        Delete Snapshots associated with the Policy.  # noqa: E501

        :param delete_snapshots: The delete_snapshots of this DetachSnapshotPolicy.  # noqa: E501
        :type: str
        """
        allowed_values = ["YES", "NO"]  # noqa: E501
        if (self._configuration.client_side_validation and
                delete_snapshots not in allowed_values):
            raise ValueError(
                "Invalid value for `delete_snapshots` ({0}), must be one of {1}"  # noqa: E501
                .format(delete_snapshots, allowed_values)
            )

        self._delete_snapshots = delete_snapshots

    @property
    def force(self):
        """Gets the force of this DetachSnapshotPolicy.  # noqa: E501

        Force Detach a Snapshot Policy from a Volume.  # noqa: E501

        :return: The force of this DetachSnapshotPolicy.  # noqa: E501
        :rtype: str
        """
        return self._force

    @force.setter
    def force(self, force):
        """Sets the force of this DetachSnapshotPolicy.

        Force Detach a Snapshot Policy from a Volume.  # noqa: E501

        :param force: The force of this DetachSnapshotPolicy.  # noqa: E501
        :type: str
        """
        allowed_values = ["YES", "NO"]  # noqa: E501
        if (self._configuration.client_side_validation and
                force not in allowed_values):
            raise ValueError(
                "Invalid value for `force` ({0}), must be one of {1}"  # noqa: E501
                .format(force, allowed_values)
            )

        self._force = force

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DetachSnapshotPolicy, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DetachSnapshotPolicy):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DetachSnapshotPolicy):
            return True

        return self.to_dict() != other.to_dict()
