# coding: utf-8

"""
    Zadara VPSA Storage Array REST API

     # Overview  This document outlines the methods available for administrating your Zadara Storage VPSA&#8482;. The Zadara Storage Array REST API   supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the   Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or   through the X-Access-Key header.  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some  time to complete. When using the API, this can cause some actions, such as large volume creation, to be undesirably asynchronous.  You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Specific Fields For Product  Some of the fields/actions used in the API should be used only for a specific product. The following tags are used to mark which   product responds to the fields/actions  VPSA Flash Array  VPSA Storage Array - Hybrid VPSA  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp2
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Vpsa.configuration import Configuration


class InlineResponse200156ResponseRoles(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'name': 'str',
        'permissions': 'list[InlineResponse200156ResponsePermissions]',
        'new_user_default': 'bool',
        'locked': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'permissions': 'permissions',
        'new_user_default': 'new_user_default',
        'locked': 'locked'
    }

    def __init__(self, id=None, name=None, permissions=None, new_user_default=None, locked=None, _configuration=None):  # noqa: E501
        """InlineResponse200156ResponseRoles - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._name = None
        self._permissions = None
        self._new_user_default = None
        self._locked = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if permissions is not None:
            self.permissions = permissions
        if new_user_default is not None:
            self.new_user_default = new_user_default
        if locked is not None:
            self.locked = locked

    @property
    def id(self):
        """Gets the id of this InlineResponse200156ResponseRoles.  # noqa: E501


        :return: The id of this InlineResponse200156ResponseRoles.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InlineResponse200156ResponseRoles.


        :param id: The id of this InlineResponse200156ResponseRoles.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this InlineResponse200156ResponseRoles.  # noqa: E501


        :return: The name of this InlineResponse200156ResponseRoles.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InlineResponse200156ResponseRoles.


        :param name: The name of this InlineResponse200156ResponseRoles.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def permissions(self):
        """Gets the permissions of this InlineResponse200156ResponseRoles.  # noqa: E501


        :return: The permissions of this InlineResponse200156ResponseRoles.  # noqa: E501
        :rtype: list[InlineResponse200156ResponsePermissions]
        """
        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """Sets the permissions of this InlineResponse200156ResponseRoles.


        :param permissions: The permissions of this InlineResponse200156ResponseRoles.  # noqa: E501
        :type: list[InlineResponse200156ResponsePermissions]
        """

        self._permissions = permissions

    @property
    def new_user_default(self):
        """Gets the new_user_default of this InlineResponse200156ResponseRoles.  # noqa: E501


        :return: The new_user_default of this InlineResponse200156ResponseRoles.  # noqa: E501
        :rtype: bool
        """
        return self._new_user_default

    @new_user_default.setter
    def new_user_default(self, new_user_default):
        """Sets the new_user_default of this InlineResponse200156ResponseRoles.


        :param new_user_default: The new_user_default of this InlineResponse200156ResponseRoles.  # noqa: E501
        :type: bool
        """

        self._new_user_default = new_user_default

    @property
    def locked(self):
        """Gets the locked of this InlineResponse200156ResponseRoles.  # noqa: E501


        :return: The locked of this InlineResponse200156ResponseRoles.  # noqa: E501
        :rtype: bool
        """
        return self._locked

    @locked.setter
    def locked(self, locked):
        """Sets the locked of this InlineResponse200156ResponseRoles.


        :param locked: The locked of this InlineResponse200156ResponseRoles.  # noqa: E501
        :type: bool
        """

        self._locked = locked

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse200156ResponseRoles, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse200156ResponseRoles):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InlineResponse200156ResponseRoles):
            return True

        return self.to_dict() != other.to_dict()
