# coding: utf-8

"""
    Zadara VPSA Storage Array REST API

     # Overview  This document outlines the methods available for administrating your Zadara Storage VPSA&#8482;. The Zadara Storage Array REST API   supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the   Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or   through the X-Access-Key header.  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some  time to complete. When using the API, this can cause some actions, such as large volume creation, to be undesirably asynchronous.  You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Specific Fields For Product  Some of the fields/actions used in the API should be used only for a specific product. The following tags are used to mark which   product responds to the fields/actions  VPSA Flash Array  VPSA Storage Array - Hybrid VPSA  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp2
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Vpsa.configuration import Configuration


class MigrateVolume(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'poolname': 'str',
        'migratesnaps': 'str',
        'dedupe': 'str',
        'compress': 'str'
    }

    attribute_map = {
        'poolname': 'poolname',
        'migratesnaps': 'migratesnaps',
        'dedupe': 'dedupe',
        'compress': 'compress'
    }

    def __init__(self, poolname=None, migratesnaps='YES', dedupe='YES', compress='YES', _configuration=None):  # noqa: E501
        """MigrateVolume - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._poolname = None
        self._migratesnaps = None
        self._dedupe = None
        self._compress = None
        self.discriminator = None

        self.poolname = poolname
        if migratesnaps is not None:
            self.migratesnaps = migratesnaps
        if dedupe is not None:
            self.dedupe = dedupe
        if compress is not None:
            self.compress = compress

    @property
    def poolname(self):
        """Gets the poolname of this MigrateVolume.  # noqa: E501

        Destination pool ID.  # noqa: E501

        :return: The poolname of this MigrateVolume.  # noqa: E501
        :rtype: str
        """
        return self._poolname

    @poolname.setter
    def poolname(self, poolname):
        """Sets the poolname of this MigrateVolume.

        Destination pool ID.  # noqa: E501

        :param poolname: The poolname of this MigrateVolume.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and poolname is None:
            raise ValueError("Invalid value for `poolname`, must not be `None`")  # noqa: E501

        self._poolname = poolname

    @property
    def migratesnaps(self):
        """Gets the migratesnaps of this MigrateVolume.  # noqa: E501


        :return: The migratesnaps of this MigrateVolume.  # noqa: E501
        :rtype: str
        """
        return self._migratesnaps

    @migratesnaps.setter
    def migratesnaps(self, migratesnaps):
        """Sets the migratesnaps of this MigrateVolume.


        :param migratesnaps: The migratesnaps of this MigrateVolume.  # noqa: E501
        :type: str
        """
        allowed_values = ["YES", "NO"]  # noqa: E501
        if (self._configuration.client_side_validation and
                migratesnaps not in allowed_values):
            raise ValueError(
                "Invalid value for `migratesnaps` ({0}), must be one of {1}"  # noqa: E501
                .format(migratesnaps, allowed_values)
            )

        self._migratesnaps = migratesnaps

    @property
    def dedupe(self):
        """Gets the dedupe of this MigrateVolume.  # noqa: E501


        :return: The dedupe of this MigrateVolume.  # noqa: E501
        :rtype: str
        """
        return self._dedupe

    @dedupe.setter
    def dedupe(self, dedupe):
        """Sets the dedupe of this MigrateVolume.


        :param dedupe: The dedupe of this MigrateVolume.  # noqa: E501
        :type: str
        """
        allowed_values = ["YES", "NO"]  # noqa: E501
        if (self._configuration.client_side_validation and
                dedupe not in allowed_values):
            raise ValueError(
                "Invalid value for `dedupe` ({0}), must be one of {1}"  # noqa: E501
                .format(dedupe, allowed_values)
            )

        self._dedupe = dedupe

    @property
    def compress(self):
        """Gets the compress of this MigrateVolume.  # noqa: E501


        :return: The compress of this MigrateVolume.  # noqa: E501
        :rtype: str
        """
        return self._compress

    @compress.setter
    def compress(self, compress):
        """Sets the compress of this MigrateVolume.


        :param compress: The compress of this MigrateVolume.  # noqa: E501
        :type: str
        """
        allowed_values = ["YES", "NO"]  # noqa: E501
        if (self._configuration.client_side_validation and
                compress not in allowed_values):
            raise ValueError(
                "Invalid value for `compress` ({0}), must be one of {1}"  # noqa: E501
                .format(compress, allowed_values)
            )

        self._compress = compress

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MigrateVolume, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MigrateVolume):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MigrateVolume):
            return True

        return self.to_dict() != other.to_dict()
