# coding: utf-8

"""
    Zadara VPSA Storage Array REST API

     # Overview  This document outlines the methods available for administrating your Zadara Storage VPSA&#8482;. The Zadara Storage Array REST API   supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the   Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or   through the X-Access-Key header.  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some  time to complete. When using the API, this can cause some actions, such as large volume creation, to be undesirably asynchronous.  You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Specific Fields For Product  Some of the fields/actions used in the API should be used only for a specific product. The following tags are used to mark which   product responds to the fields/actions  VPSA Flash Array  VPSA Storage Array - Hybrid VPSA  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp2
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Vpsa.configuration import Configuration


class SetEncriptionPass(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'current_encryption_pwd': 'str',
        'encryption_pwd': 'str'
    }

    attribute_map = {
        'current_encryption_pwd': 'current_encryption_pwd',
        'encryption_pwd': 'encryption_pwd'
    }

    def __init__(self, current_encryption_pwd=None, encryption_pwd=None, _configuration=None):  # noqa: E501
        """SetEncriptionPass - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._current_encryption_pwd = None
        self._encryption_pwd = None
        self.discriminator = None

        self.current_encryption_pwd = current_encryption_pwd
        self.encryption_pwd = encryption_pwd

    @property
    def current_encryption_pwd(self):
        """Gets the current_encryption_pwd of this SetEncriptionPass.  # noqa: E501

        Current master encryption password.  # noqa: E501

        :return: The current_encryption_pwd of this SetEncriptionPass.  # noqa: E501
        :rtype: str
        """
        return self._current_encryption_pwd

    @current_encryption_pwd.setter
    def current_encryption_pwd(self, current_encryption_pwd):
        """Sets the current_encryption_pwd of this SetEncriptionPass.

        Current master encryption password.  # noqa: E501

        :param current_encryption_pwd: The current_encryption_pwd of this SetEncriptionPass.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and current_encryption_pwd is None:
            raise ValueError("Invalid value for `current_encryption_pwd`, must not be `None`")  # noqa: E501

        self._current_encryption_pwd = current_encryption_pwd

    @property
    def encryption_pwd(self):
        """Gets the encryption_pwd of this SetEncriptionPass.  # noqa: E501

        The master encryption password to set.  # noqa: E501

        :return: The encryption_pwd of this SetEncriptionPass.  # noqa: E501
        :rtype: str
        """
        return self._encryption_pwd

    @encryption_pwd.setter
    def encryption_pwd(self, encryption_pwd):
        """Sets the encryption_pwd of this SetEncriptionPass.

        The master encryption password to set.  # noqa: E501

        :param encryption_pwd: The encryption_pwd of this SetEncriptionPass.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and encryption_pwd is None:
            raise ValueError("Invalid value for `encryption_pwd`, must not be `None`")  # noqa: E501

        self._encryption_pwd = encryption_pwd

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SetEncriptionPass, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SetEncriptionPass):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SetEncriptionPass):
            return True

        return self.to_dict() != other.to_dict()
