# coding: utf-8

"""
    Zadara VPSA Storage Array REST API

     # Overview  This document outlines the methods available for administrating your Zadara Storage VPSA&#8482;. The Zadara Storage Array REST API   supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the   Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or   through the X-Access-Key header.  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some  time to complete. When using the API, this can cause some actions, such as large volume creation, to be undesirably asynchronous.  You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Specific Fields For Product  Some of the fields/actions used in the API should be used only for a specific product. The following tags are used to mark which   product responds to the fields/actions  VPSA Flash Array  VPSA Storage Array - Hybrid VPSA  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp2
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Vpsa.configuration import Configuration


class SnapshotSetParam(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'cg': 'str',
        'mng_for': 'str'
    }

    attribute_map = {
        'name': 'name',
        'cg': 'cg',
        'mng_for': 'mng_for'
    }

    def __init__(self, name=None, cg=None, mng_for=None, _configuration=None):  # noqa: E501
        """SnapshotSetParam - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._cg = None
        self._mng_for = None
        self.discriminator = None

        self.name = name
        self.cg = cg
        if mng_for is not None:
            self.mng_for = mng_for

    @property
    def name(self):
        """Gets the name of this SnapshotSetParam.  # noqa: E501


        :return: The name of this SnapshotSetParam.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SnapshotSetParam.


        :param name: The name of this SnapshotSetParam.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def cg(self):
        """Gets the cg of this SnapshotSetParam.  # noqa: E501


        :return: The cg of this SnapshotSetParam.  # noqa: E501
        :rtype: str
        """
        return self._cg

    @cg.setter
    def cg(self, cg):
        """Sets the cg of this SnapshotSetParam.


        :param cg: The cg of this SnapshotSetParam.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and cg is None:
            raise ValueError("Invalid value for `cg`, must not be `None`")  # noqa: E501

        self._cg = cg

    @property
    def mng_for(self):
        """Gets the mng_for of this SnapshotSetParam.  # noqa: E501

        For externally managed VPSA, set what the snapshot is managed for.  # noqa: E501

        :return: The mng_for of this SnapshotSetParam.  # noqa: E501
        :rtype: str
        """
        return self._mng_for

    @mng_for.setter
    def mng_for(self, mng_for):
        """Sets the mng_for of this SnapshotSetParam.

        For externally managed VPSA, set what the snapshot is managed for.  # noqa: E501

        :param mng_for: The mng_for of this SnapshotSetParam.  # noqa: E501
        :type: str
        """

        self._mng_for = mng_for

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SnapshotSetParam, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SnapshotSetParam):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SnapshotSetParam):
            return True

        return self.to_dict() != other.to_dict()
