# coding: utf-8

"""
    Zadara VPSA Object Storage REST API

    # Overview  This document outlines the methods available for administrating your VPSA&#174; Object Storage. The API supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or through the X-Access-Key header. Alternately, you can use the username and password parameters for authentication, but we do not recommend this method for anything other than possibly retrieving an API key.  By default , all operations are allowed only to VPSA Object Storage admin. Some actions are allowed by an account admin and they will be marked on the action's header  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some time to complete. When using the API, this can cause some actions, such as adding drives to storage policy, to be undesirably asynchronous. You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Metering API  Metering information can be retrieved using the VPSA Object Storage API for the following components:  - Accounts - Users - Drives - Virtual Controllers - Load Balancer Groups - Storage Policies  Metering information returned by the API is subject to the following constraints:  - 10 seconds interval - 1 hour range - 1 minute interval - 1 day range - 1 hour interval - 30 days range  Values outside the accepted range will be returned as 0.  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp2
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from Zios.api_client import ApiClient


class ObjectStorageDestinationsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_ros_destination(self, create_object_storage_destination, **kwargs):  # noqa: E501
        """create_ros_destination  # noqa: E501

        Create an object storage destination. Connection will be tested.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_ros_destination(create_object_storage_destination, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateObjectStorageDestination create_object_storage_destination: (required)
        :return: InlineResponse20028
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_ros_destination_with_http_info(create_object_storage_destination, **kwargs)  # noqa: E501
        else:
            (data) = self.create_ros_destination_with_http_info(create_object_storage_destination, **kwargs)  # noqa: E501
            return data

    def create_ros_destination_with_http_info(self, create_object_storage_destination, **kwargs):  # noqa: E501
        """create_ros_destination  # noqa: E501

        Create an object storage destination. Connection will be tested.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_ros_destination_with_http_info(create_object_storage_destination, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateObjectStorageDestination create_object_storage_destination: (required)
        :return: InlineResponse20028
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['create_object_storage_destination']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_ros_destination" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'create_object_storage_destination' is set
        if self.api_client.client_side_validation and ('create_object_storage_destination' not in params or
                                                       params['create_object_storage_destination'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `create_object_storage_destination` when calling `create_ros_destination`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'create_object_storage_destination' in params:
            body_params = params['create_object_storage_destination']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/zios/object_storage_destinations.json', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20028',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_object_storage_destination(self, target_ext_name, delete_object_storage_destination, **kwargs):  # noqa: E501
        """delete_object_storage_destination  # noqa: E501

        Delete an object storage destination.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_object_storage_destination(target_ext_name, delete_object_storage_destination, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str target_ext_name: (required)
        :param DeleteObjectStorageDestination delete_object_storage_destination: (required)
        :return: InlineResponse20031
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_object_storage_destination_with_http_info(target_ext_name, delete_object_storage_destination, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_object_storage_destination_with_http_info(target_ext_name, delete_object_storage_destination, **kwargs)  # noqa: E501
            return data

    def delete_object_storage_destination_with_http_info(self, target_ext_name, delete_object_storage_destination, **kwargs):  # noqa: E501
        """delete_object_storage_destination  # noqa: E501

        Delete an object storage destination.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_object_storage_destination_with_http_info(target_ext_name, delete_object_storage_destination, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str target_ext_name: (required)
        :param DeleteObjectStorageDestination delete_object_storage_destination: (required)
        :return: InlineResponse20031
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['target_ext_name', 'delete_object_storage_destination']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_object_storage_destination" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'target_ext_name' is set
        if self.api_client.client_side_validation and ('target_ext_name' not in params or
                                                       params['target_ext_name'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `target_ext_name` when calling `delete_object_storage_destination`")  # noqa: E501
        # verify the required parameter 'delete_object_storage_destination' is set
        if self.api_client.client_side_validation and ('delete_object_storage_destination' not in params or
                                                       params['delete_object_storage_destination'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `delete_object_storage_destination` when calling `delete_object_storage_destination`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'target_ext_name' in params:
            path_params['target_ext_name'] = params['target_ext_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'delete_object_storage_destination' in params:
            body_params = params['delete_object_storage_destination']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/zios/object_storage_destinations/{target_ext_name}.json', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20031',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_object_storage_destination(self, target_ext_name, **kwargs):  # noqa: E501
        """get_object_storage_destination  # noqa: E501

        Get one Object Storage Destination.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_object_storage_destination(target_ext_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str target_ext_name: (required)
        :return: InlineResponse20029
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_object_storage_destination_with_http_info(target_ext_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_object_storage_destination_with_http_info(target_ext_name, **kwargs)  # noqa: E501
            return data

    def get_object_storage_destination_with_http_info(self, target_ext_name, **kwargs):  # noqa: E501
        """get_object_storage_destination  # noqa: E501

        Get one Object Storage Destination.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_object_storage_destination_with_http_info(target_ext_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str target_ext_name: (required)
        :return: InlineResponse20029
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['target_ext_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_object_storage_destination" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'target_ext_name' is set
        if self.api_client.client_side_validation and ('target_ext_name' not in params or
                                                       params['target_ext_name'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `target_ext_name` when calling `get_object_storage_destination`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'target_ext_name' in params:
            path_params['target_ext_name'] = params['target_ext_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/zios/object_storage_destinations/{target_ext_name}.json', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20029',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_ros_destinations_from_account(self, **kwargs):  # noqa: E501
        """get_ros_destinations_from_account  # noqa: E501

        Get a list of Object Storage Destinations in current user's account or in a container's account.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_ros_destinations_from_account(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str container_account: Container account id
        :return: InlineResponse20027
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_ros_destinations_from_account_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_ros_destinations_from_account_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_ros_destinations_from_account_with_http_info(self, **kwargs):  # noqa: E501
        """get_ros_destinations_from_account  # noqa: E501

        Get a list of Object Storage Destinations in current user's account or in a container's account.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_ros_destinations_from_account_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str container_account: Container account id
        :return: InlineResponse20027
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['container_account']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_ros_destinations_from_account" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'container_account' in params:
            query_params.append(('container_account', params['container_account']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/zios/object_storage_destinations.json', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20027',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_object_storage_destination(self, target_ext_name, update_object_storage_destination, **kwargs):  # noqa: E501
        """update_object_storage_destination  # noqa: E501

        Update an object storage destination. Connection will be tested.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_object_storage_destination(target_ext_name, update_object_storage_destination, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str target_ext_name: (required)
        :param UpdateObjectStorageDestination update_object_storage_destination: (required)
        :return: InlineResponse20030
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_object_storage_destination_with_http_info(target_ext_name, update_object_storage_destination, **kwargs)  # noqa: E501
        else:
            (data) = self.update_object_storage_destination_with_http_info(target_ext_name, update_object_storage_destination, **kwargs)  # noqa: E501
            return data

    def update_object_storage_destination_with_http_info(self, target_ext_name, update_object_storage_destination, **kwargs):  # noqa: E501
        """update_object_storage_destination  # noqa: E501

        Update an object storage destination. Connection will be tested.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_object_storage_destination_with_http_info(target_ext_name, update_object_storage_destination, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str target_ext_name: (required)
        :param UpdateObjectStorageDestination update_object_storage_destination: (required)
        :return: InlineResponse20030
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['target_ext_name', 'update_object_storage_destination']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_object_storage_destination" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'target_ext_name' is set
        if self.api_client.client_side_validation and ('target_ext_name' not in params or
                                                       params['target_ext_name'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `target_ext_name` when calling `update_object_storage_destination`")  # noqa: E501
        # verify the required parameter 'update_object_storage_destination' is set
        if self.api_client.client_side_validation and ('update_object_storage_destination' not in params or
                                                       params['update_object_storage_destination'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `update_object_storage_destination` when calling `update_object_storage_destination`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'target_ext_name' in params:
            path_params['target_ext_name'] = params['target_ext_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'update_object_storage_destination' in params:
            body_params = params['update_object_storage_destination']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/zios/object_storage_destinations/{target_ext_name}.json', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20030',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
