# coding: utf-8

"""
    Zadara VPSA Object Storage REST API

    # Overview  This document outlines the methods available for administrating your VPSA&#174; Object Storage. The API supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or through the X-Access-Key header. Alternately, you can use the username and password parameters for authentication, but we do not recommend this method for anything other than possibly retrieving an API key.  By default , all operations are allowed only to VPSA Object Storage admin. Some actions are allowed by an account admin and they will be marked on the action's header  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some time to complete. When using the API, this can cause some actions, such as adding drives to storage policy, to be undesirably asynchronous. You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Metering API  Metering information can be retrieved using the VPSA Object Storage API for the following components:  - Accounts - Users - Drives - Virtual Controllers - Load Balancer Groups - Storage Policies  Metering information returned by the API is subject to the following constraints:  - 10 seconds interval - 1 hour range - 1 minute interval - 1 day range - 1 hour interval - 30 days range  Values outside the accepted range will be returned as 0.  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp2
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Zios.configuration import Configuration


class InlineResponse2004ResponseUsers(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'update_time': 'str',
        'name': 'str',
        'enabled': 'str',
        'id': 'str',
        'create_time': 'str',
        'init_password_changed': 'str',
        'role_list': 'list[str]',
        'is_system_user': 'str',
        'account_name': 'str',
        'account_id': 'str'
    }

    attribute_map = {
        'update_time': 'update_time',
        'name': 'name',
        'enabled': 'enabled',
        'id': 'id',
        'create_time': 'create_time',
        'init_password_changed': 'init_password_changed',
        'role_list': 'role_list',
        'is_system_user': 'is_system_user',
        'account_name': 'account_name',
        'account_id': 'account_id'
    }

    def __init__(self, update_time=None, name=None, enabled=None, id=None, create_time=None, init_password_changed=None, role_list=None, is_system_user=None, account_name=None, account_id=None, _configuration=None):  # noqa: E501
        """InlineResponse2004ResponseUsers - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._update_time = None
        self._name = None
        self._enabled = None
        self._id = None
        self._create_time = None
        self._init_password_changed = None
        self._role_list = None
        self._is_system_user = None
        self._account_name = None
        self._account_id = None
        self.discriminator = None

        if update_time is not None:
            self.update_time = update_time
        if name is not None:
            self.name = name
        if enabled is not None:
            self.enabled = enabled
        if id is not None:
            self.id = id
        if create_time is not None:
            self.create_time = create_time
        if init_password_changed is not None:
            self.init_password_changed = init_password_changed
        if role_list is not None:
            self.role_list = role_list
        if is_system_user is not None:
            self.is_system_user = is_system_user
        if account_name is not None:
            self.account_name = account_name
        if account_id is not None:
            self.account_id = account_id

    @property
    def update_time(self):
        """Gets the update_time of this InlineResponse2004ResponseUsers.  # noqa: E501


        :return: The update_time of this InlineResponse2004ResponseUsers.  # noqa: E501
        :rtype: str
        """
        return self._update_time

    @update_time.setter
    def update_time(self, update_time):
        """Sets the update_time of this InlineResponse2004ResponseUsers.


        :param update_time: The update_time of this InlineResponse2004ResponseUsers.  # noqa: E501
        :type: str
        """

        self._update_time = update_time

    @property
    def name(self):
        """Gets the name of this InlineResponse2004ResponseUsers.  # noqa: E501


        :return: The name of this InlineResponse2004ResponseUsers.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InlineResponse2004ResponseUsers.


        :param name: The name of this InlineResponse2004ResponseUsers.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def enabled(self):
        """Gets the enabled of this InlineResponse2004ResponseUsers.  # noqa: E501


        :return: The enabled of this InlineResponse2004ResponseUsers.  # noqa: E501
        :rtype: str
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this InlineResponse2004ResponseUsers.


        :param enabled: The enabled of this InlineResponse2004ResponseUsers.  # noqa: E501
        :type: str
        """

        self._enabled = enabled

    @property
    def id(self):
        """Gets the id of this InlineResponse2004ResponseUsers.  # noqa: E501


        :return: The id of this InlineResponse2004ResponseUsers.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InlineResponse2004ResponseUsers.


        :param id: The id of this InlineResponse2004ResponseUsers.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def create_time(self):
        """Gets the create_time of this InlineResponse2004ResponseUsers.  # noqa: E501


        :return: The create_time of this InlineResponse2004ResponseUsers.  # noqa: E501
        :rtype: str
        """
        return self._create_time

    @create_time.setter
    def create_time(self, create_time):
        """Sets the create_time of this InlineResponse2004ResponseUsers.


        :param create_time: The create_time of this InlineResponse2004ResponseUsers.  # noqa: E501
        :type: str
        """

        self._create_time = create_time

    @property
    def init_password_changed(self):
        """Gets the init_password_changed of this InlineResponse2004ResponseUsers.  # noqa: E501


        :return: The init_password_changed of this InlineResponse2004ResponseUsers.  # noqa: E501
        :rtype: str
        """
        return self._init_password_changed

    @init_password_changed.setter
    def init_password_changed(self, init_password_changed):
        """Sets the init_password_changed of this InlineResponse2004ResponseUsers.


        :param init_password_changed: The init_password_changed of this InlineResponse2004ResponseUsers.  # noqa: E501
        :type: str
        """

        self._init_password_changed = init_password_changed

    @property
    def role_list(self):
        """Gets the role_list of this InlineResponse2004ResponseUsers.  # noqa: E501


        :return: The role_list of this InlineResponse2004ResponseUsers.  # noqa: E501
        :rtype: list[str]
        """
        return self._role_list

    @role_list.setter
    def role_list(self, role_list):
        """Sets the role_list of this InlineResponse2004ResponseUsers.


        :param role_list: The role_list of this InlineResponse2004ResponseUsers.  # noqa: E501
        :type: list[str]
        """

        self._role_list = role_list

    @property
    def is_system_user(self):
        """Gets the is_system_user of this InlineResponse2004ResponseUsers.  # noqa: E501


        :return: The is_system_user of this InlineResponse2004ResponseUsers.  # noqa: E501
        :rtype: str
        """
        return self._is_system_user

    @is_system_user.setter
    def is_system_user(self, is_system_user):
        """Sets the is_system_user of this InlineResponse2004ResponseUsers.


        :param is_system_user: The is_system_user of this InlineResponse2004ResponseUsers.  # noqa: E501
        :type: str
        """

        self._is_system_user = is_system_user

    @property
    def account_name(self):
        """Gets the account_name of this InlineResponse2004ResponseUsers.  # noqa: E501


        :return: The account_name of this InlineResponse2004ResponseUsers.  # noqa: E501
        :rtype: str
        """
        return self._account_name

    @account_name.setter
    def account_name(self, account_name):
        """Sets the account_name of this InlineResponse2004ResponseUsers.


        :param account_name: The account_name of this InlineResponse2004ResponseUsers.  # noqa: E501
        :type: str
        """

        self._account_name = account_name

    @property
    def account_id(self):
        """Gets the account_id of this InlineResponse2004ResponseUsers.  # noqa: E501


        :return: The account_id of this InlineResponse2004ResponseUsers.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this InlineResponse2004ResponseUsers.


        :param account_id: The account_id of this InlineResponse2004ResponseUsers.  # noqa: E501
        :type: str
        """

        self._account_id = account_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse2004ResponseUsers, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse2004ResponseUsers):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InlineResponse2004ResponseUsers):
            return True

        return self.to_dict() != other.to_dict()
