# coding: utf-8

"""
    Zadara VPSA Object Storage REST API

    # Overview  This document outlines the methods available for administrating your VPSA&#174; Object Storage. The API supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or through the X-Access-Key header. Alternately, you can use the username and password parameters for authentication, but we do not recommend this method for anything other than possibly retrieving an API key.  By default , all operations are allowed only to VPSA Object Storage admin. Some actions are allowed by an account admin and they will be marked on the action's header  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some time to complete. When using the API, this can cause some actions, such as adding drives to storage policy, to be undesirably asynchronous. You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Metering API  Metering information can be retrieved using the VPSA Object Storage API for the following components:  - Accounts - Users - Drives - Virtual Controllers - Load Balancer Groups - Storage Policies  Metering information returned by the API is subject to the following constraints:  - 10 seconds interval - 1 hour range - 1 minute interval - 1 day range - 1 hour interval - 30 days range  Values outside the accepted range will be returned as 0.  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp2
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Zios.configuration import Configuration


class InlineResponse20062ResponseDisks(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'display_name': 'str',
        'disk_type': 'str',
        'disk_uuid': 'str',
        'storage_node': 'str',
        'vc': 'str',
        'allocation_zone': 'str',
        'allocation_zone_display_name': 'str',
        'storage_policy': 'str',
        'status': 'str',
        'capacity': 'int',
        'used_capacity': 'int',
        'avail_capacity': 'int',
        'total_capacity': 'int',
        'created_at': 'str',
        'modified_at': 'str'
    }

    attribute_map = {
        'name': 'name',
        'display_name': 'display_name',
        'disk_type': 'disk_type',
        'disk_uuid': 'disk_uuid',
        'storage_node': 'storage_node',
        'vc': 'vc',
        'allocation_zone': 'allocation-zone',
        'allocation_zone_display_name': 'allocation-zone_display_name',
        'storage_policy': 'storage_policy',
        'status': 'status',
        'capacity': 'capacity',
        'used_capacity': 'used_capacity',
        'avail_capacity': 'avail_capacity',
        'total_capacity': 'total_capacity',
        'created_at': 'created_at',
        'modified_at': 'modified_at'
    }

    def __init__(self, name=None, display_name=None, disk_type=None, disk_uuid=None, storage_node=None, vc=None, allocation_zone=None, allocation_zone_display_name=None, storage_policy=None, status=None, capacity=None, used_capacity=None, avail_capacity=None, total_capacity=None, created_at=None, modified_at=None, _configuration=None):  # noqa: E501
        """InlineResponse20062ResponseDisks - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._display_name = None
        self._disk_type = None
        self._disk_uuid = None
        self._storage_node = None
        self._vc = None
        self._allocation_zone = None
        self._allocation_zone_display_name = None
        self._storage_policy = None
        self._status = None
        self._capacity = None
        self._used_capacity = None
        self._avail_capacity = None
        self._total_capacity = None
        self._created_at = None
        self._modified_at = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if display_name is not None:
            self.display_name = display_name
        if disk_type is not None:
            self.disk_type = disk_type
        if disk_uuid is not None:
            self.disk_uuid = disk_uuid
        if storage_node is not None:
            self.storage_node = storage_node
        if vc is not None:
            self.vc = vc
        if allocation_zone is not None:
            self.allocation_zone = allocation_zone
        if allocation_zone_display_name is not None:
            self.allocation_zone_display_name = allocation_zone_display_name
        if storage_policy is not None:
            self.storage_policy = storage_policy
        if status is not None:
            self.status = status
        if capacity is not None:
            self.capacity = capacity
        if used_capacity is not None:
            self.used_capacity = used_capacity
        if avail_capacity is not None:
            self.avail_capacity = avail_capacity
        if total_capacity is not None:
            self.total_capacity = total_capacity
        if created_at is not None:
            self.created_at = created_at
        if modified_at is not None:
            self.modified_at = modified_at

    @property
    def name(self):
        """Gets the name of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The name of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InlineResponse20062ResponseDisks.


        :param name: The name of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def display_name(self):
        """Gets the display_name of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The display_name of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this InlineResponse20062ResponseDisks.


        :param display_name: The display_name of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def disk_type(self):
        """Gets the disk_type of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The disk_type of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: str
        """
        return self._disk_type

    @disk_type.setter
    def disk_type(self, disk_type):
        """Sets the disk_type of this InlineResponse20062ResponseDisks.


        :param disk_type: The disk_type of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: str
        """

        self._disk_type = disk_type

    @property
    def disk_uuid(self):
        """Gets the disk_uuid of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The disk_uuid of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: str
        """
        return self._disk_uuid

    @disk_uuid.setter
    def disk_uuid(self, disk_uuid):
        """Sets the disk_uuid of this InlineResponse20062ResponseDisks.


        :param disk_uuid: The disk_uuid of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: str
        """

        self._disk_uuid = disk_uuid

    @property
    def storage_node(self):
        """Gets the storage_node of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The storage_node of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: str
        """
        return self._storage_node

    @storage_node.setter
    def storage_node(self, storage_node):
        """Sets the storage_node of this InlineResponse20062ResponseDisks.


        :param storage_node: The storage_node of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: str
        """

        self._storage_node = storage_node

    @property
    def vc(self):
        """Gets the vc of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The vc of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: str
        """
        return self._vc

    @vc.setter
    def vc(self, vc):
        """Sets the vc of this InlineResponse20062ResponseDisks.


        :param vc: The vc of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: str
        """

        self._vc = vc

    @property
    def allocation_zone(self):
        """Gets the allocation_zone of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The allocation_zone of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: str
        """
        return self._allocation_zone

    @allocation_zone.setter
    def allocation_zone(self, allocation_zone):
        """Sets the allocation_zone of this InlineResponse20062ResponseDisks.


        :param allocation_zone: The allocation_zone of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: str
        """

        self._allocation_zone = allocation_zone

    @property
    def allocation_zone_display_name(self):
        """Gets the allocation_zone_display_name of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The allocation_zone_display_name of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: str
        """
        return self._allocation_zone_display_name

    @allocation_zone_display_name.setter
    def allocation_zone_display_name(self, allocation_zone_display_name):
        """Sets the allocation_zone_display_name of this InlineResponse20062ResponseDisks.


        :param allocation_zone_display_name: The allocation_zone_display_name of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: str
        """

        self._allocation_zone_display_name = allocation_zone_display_name

    @property
    def storage_policy(self):
        """Gets the storage_policy of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The storage_policy of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: str
        """
        return self._storage_policy

    @storage_policy.setter
    def storage_policy(self, storage_policy):
        """Sets the storage_policy of this InlineResponse20062ResponseDisks.


        :param storage_policy: The storage_policy of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: str
        """

        self._storage_policy = storage_policy

    @property
    def status(self):
        """Gets the status of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The status of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this InlineResponse20062ResponseDisks.


        :param status: The status of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def capacity(self):
        """Gets the capacity of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The capacity of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: int
        """
        return self._capacity

    @capacity.setter
    def capacity(self, capacity):
        """Sets the capacity of this InlineResponse20062ResponseDisks.


        :param capacity: The capacity of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: int
        """

        self._capacity = capacity

    @property
    def used_capacity(self):
        """Gets the used_capacity of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The used_capacity of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: int
        """
        return self._used_capacity

    @used_capacity.setter
    def used_capacity(self, used_capacity):
        """Sets the used_capacity of this InlineResponse20062ResponseDisks.


        :param used_capacity: The used_capacity of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: int
        """

        self._used_capacity = used_capacity

    @property
    def avail_capacity(self):
        """Gets the avail_capacity of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The avail_capacity of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: int
        """
        return self._avail_capacity

    @avail_capacity.setter
    def avail_capacity(self, avail_capacity):
        """Sets the avail_capacity of this InlineResponse20062ResponseDisks.


        :param avail_capacity: The avail_capacity of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: int
        """

        self._avail_capacity = avail_capacity

    @property
    def total_capacity(self):
        """Gets the total_capacity of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The total_capacity of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: int
        """
        return self._total_capacity

    @total_capacity.setter
    def total_capacity(self, total_capacity):
        """Sets the total_capacity of this InlineResponse20062ResponseDisks.


        :param total_capacity: The total_capacity of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: int
        """

        self._total_capacity = total_capacity

    @property
    def created_at(self):
        """Gets the created_at of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The created_at of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this InlineResponse20062ResponseDisks.


        :param created_at: The created_at of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def modified_at(self):
        """Gets the modified_at of this InlineResponse20062ResponseDisks.  # noqa: E501


        :return: The modified_at of this InlineResponse20062ResponseDisks.  # noqa: E501
        :rtype: str
        """
        return self._modified_at

    @modified_at.setter
    def modified_at(self, modified_at):
        """Sets the modified_at of this InlineResponse20062ResponseDisks.


        :param modified_at: The modified_at of this InlineResponse20062ResponseDisks.  # noqa: E501
        :type: str
        """

        self._modified_at = modified_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse20062ResponseDisks, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse20062ResponseDisks):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InlineResponse20062ResponseDisks):
            return True

        return self.to_dict() != other.to_dict()
