# coding: utf-8

"""
    Zadara VPSA Object Storage REST API

    # Overview  This document outlines the methods available for administrating your VPSA&#174; Object Storage. The API supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or through the X-Access-Key header. Alternately, you can use the username and password parameters for authentication, but we do not recommend this method for anything other than possibly retrieving an API key.  By default , all operations are allowed only to VPSA Object Storage admin. Some actions are allowed by an account admin and they will be marked on the action's header  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some time to complete. When using the API, this can cause some actions, such as adding drives to storage policy, to be undesirably asynchronous. You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Metering API  Metering information can be retrieved using the VPSA Object Storage API for the following components:  - Accounts - Users - Drives - Virtual Controllers - Load Balancer Groups - Storage Policies  Metering information returned by the API is subject to the following constraints:  - 10 seconds interval - 1 hour range - 1 minute interval - 1 day range - 1 hour interval - 30 days range  Values outside the accepted range will be returned as 0.  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp2
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Zios.configuration import Configuration


class SetQuotaAlertStatusAndThreshold(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'notify_admin': 'bool',
        'warning_threshold': 'int',
        'emergency_threshold': 'int',
        'is_daily': 'bool'
    }

    attribute_map = {
        'notify_admin': 'notify_admin',
        'warning_threshold': 'warning_threshold',
        'emergency_threshold': 'emergency_threshold',
        'is_daily': 'is_daily'
    }

    def __init__(self, notify_admin=None, warning_threshold=None, emergency_threshold=None, is_daily=None, _configuration=None):  # noqa: E501
        """SetQuotaAlertStatusAndThreshold - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._notify_admin = None
        self._warning_threshold = None
        self._emergency_threshold = None
        self._is_daily = None
        self.discriminator = None

        self.notify_admin = notify_admin
        self.warning_threshold = warning_threshold
        self.emergency_threshold = emergency_threshold
        if is_daily is not None:
            self.is_daily = is_daily

    @property
    def notify_admin(self):
        """Gets the notify_admin of this SetQuotaAlertStatusAndThreshold.  # noqa: E501

        ZIOS_ADMIN account administrators will be notified with account/container quota alert upon utilizing the warning and emergency thresholds and 100% of its quota.  # noqa: E501

        :return: The notify_admin of this SetQuotaAlertStatusAndThreshold.  # noqa: E501
        :rtype: bool
        """
        return self._notify_admin

    @notify_admin.setter
    def notify_admin(self, notify_admin):
        """Sets the notify_admin of this SetQuotaAlertStatusAndThreshold.

        ZIOS_ADMIN account administrators will be notified with account/container quota alert upon utilizing the warning and emergency thresholds and 100% of its quota.  # noqa: E501

        :param notify_admin: The notify_admin of this SetQuotaAlertStatusAndThreshold.  # noqa: E501
        :type: bool
        """
        if self._configuration.client_side_validation and notify_admin is None:
            raise ValueError("Invalid value for `notify_admin`, must not be `None`")  # noqa: E501

        self._notify_admin = notify_admin

    @property
    def warning_threshold(self):
        """Gets the warning_threshold of this SetQuotaAlertStatusAndThreshold.  # noqa: E501

        Quota Warning Alert Threshold Percentage (1-100)  # noqa: E501

        :return: The warning_threshold of this SetQuotaAlertStatusAndThreshold.  # noqa: E501
        :rtype: int
        """
        return self._warning_threshold

    @warning_threshold.setter
    def warning_threshold(self, warning_threshold):
        """Sets the warning_threshold of this SetQuotaAlertStatusAndThreshold.

        Quota Warning Alert Threshold Percentage (1-100)  # noqa: E501

        :param warning_threshold: The warning_threshold of this SetQuotaAlertStatusAndThreshold.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and warning_threshold is None:
            raise ValueError("Invalid value for `warning_threshold`, must not be `None`")  # noqa: E501

        self._warning_threshold = warning_threshold

    @property
    def emergency_threshold(self):
        """Gets the emergency_threshold of this SetQuotaAlertStatusAndThreshold.  # noqa: E501

        Quota Emergency Alert Threshold Percentage (1-100)  # noqa: E501

        :return: The emergency_threshold of this SetQuotaAlertStatusAndThreshold.  # noqa: E501
        :rtype: int
        """
        return self._emergency_threshold

    @emergency_threshold.setter
    def emergency_threshold(self, emergency_threshold):
        """Sets the emergency_threshold of this SetQuotaAlertStatusAndThreshold.

        Quota Emergency Alert Threshold Percentage (1-100)  # noqa: E501

        :param emergency_threshold: The emergency_threshold of this SetQuotaAlertStatusAndThreshold.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and emergency_threshold is None:
            raise ValueError("Invalid value for `emergency_threshold`, must not be `None`")  # noqa: E501

        self._emergency_threshold = emergency_threshold

    @property
    def is_daily(self):
        """Gets the is_daily of this SetQuotaAlertStatusAndThreshold.  # noqa: E501

        Controls the quota notification frequency. Can be daily or one time.  # noqa: E501

        :return: The is_daily of this SetQuotaAlertStatusAndThreshold.  # noqa: E501
        :rtype: bool
        """
        return self._is_daily

    @is_daily.setter
    def is_daily(self, is_daily):
        """Sets the is_daily of this SetQuotaAlertStatusAndThreshold.

        Controls the quota notification frequency. Can be daily or one time.  # noqa: E501

        :param is_daily: The is_daily of this SetQuotaAlertStatusAndThreshold.  # noqa: E501
        :type: bool
        """

        self._is_daily = is_daily

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SetQuotaAlertStatusAndThreshold, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SetQuotaAlertStatusAndThreshold):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SetQuotaAlertStatusAndThreshold):
            return True

        return self.to_dict() != other.to_dict()
